//Kevin Rye - 2017
//ATtiny85 audio processing for VFD Clock V1
//compiled on Arduino 1.6.10

//I/O
const int audioOut = 1; //D1 //PWM
const int alarmIn = 0; //D0 PWM
const int shutAudio = 3; //D3

//audio
const int Note_C  = 239;

//timers
unsigned long previousMillis = 0;
const long interval = 1000; // tone interval
int counter = 0;
bool startCounter = false;

void setup() {

  pinMode(audioOut, OUTPUT);
  pinMode(alarmIn, INPUT);
  pinMode(shutAudio, OUTPUT);
  digitalWrite(shutAudio, LOW); //turns it off
  
  delay(50000); //give the system time to power on to avoid false alarm trigger at power on (Ideally 3000ms, but needs to be a longer delay becasue of the 1Mhz clock)
}

void loop() {

  if ((digitalRead(alarmIn) == LOW) && (false == startCounter)) {

    startCounter = true;
    digitalWrite(shutAudio, HIGH); //turn on amplifier
  } 

  if (true == startCounter) {

    soundAlarm();
  } 

} //end loop

void TinyTone(unsigned char divisor, unsigned char octave, unsigned long duration) {
  TCCR1 = 0x90 | (8 - octave); // for 1MHz clock
  OCR1C = divisor - 1;       // set the OCR
  delay(duration);
  TCCR1 = 0x90;              // stop the counter
}

// Play note
void soundAlarm(void) {
  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis >= interval) {
    previousMillis = currentMillis;
    TinyTone(Note_C, 4, 500);

    counter++; //20 tones
    if (counter > 19) {
      counter = 0;
      startCounter = false;
      digitalWrite(shutAudio, LOW);
    }
  }
}

